{*******************************************************************************
Unit Main - This unit contains all the UI code.
*******************************************************************************}
unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ThreadController;

type
  { TForm_Main }

  TForm_Main = class(TForm)
    Btn_StartOneThread: TButton;
    Btn_StopOneThread: TButton;
    Btn_StopAllThreads: TButton;
    Lab_Threads_Desc: TLabel;
    Lab_Threads_Num: TLabel;
    procedure Btn_StartOneThreadClick(Sender: TObject);
    procedure Btn_StopAllThreadsClick(Sender: TObject);
    procedure Btn_StopOneThreadClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    AThreadController: TThreadController;
    procedure UpdateUI;
  public
    { public declarations }
  end;

var
  Form_Main: TForm_Main;

implementation

{$R *.lfm}

{ TForm_Main }

procedure TForm_Main.Btn_StartOneThreadClick(Sender: TObject);
begin
  AThreadController.CreateOneThread;
  UpdateUI;
end;

procedure TForm_Main.Btn_StopAllThreadsClick(Sender: TObject);
begin
  AThreadController.TerminateAllThreads;
  UpdateUI;
end;

procedure TForm_Main.Btn_StopOneThreadClick(Sender: TObject);
begin
  AThreadController.TerminateOneThread;
  UpdateUI;
end;

//The end of the program.
procedure TForm_Main.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  FreeAndNil(AThreadController);
  CanClose := True;
end;

//The Beginning of the Program.
procedure TForm_Main.FormCreate(Sender: TObject);
begin
  AThreadController:= TThreadController.Create;
end;

//Updates the UI to show the number of currently running threads.
procedure TForm_Main.UpdateUI;
begin
  Lab_Threads_Num.Caption := IntToStr(AThreadController.GetNumberOfThreads);
end;

end.


