{*******************************************************************************
Unit SimpleThread - This unit contains code for a very simple thread.
*******************************************************************************}
unit simplethread;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type
  { simpleThread }

  //Class for a very simple thread.
  TSimpleThread = class(TThread)
  protected
    procedure Execute; override;
  public
    constructor Create(CreateSuspended: boolean);
  end;

implementation

constructor TSimpleThread.Create(CreateSuspended: boolean);
begin
  //If the thread is terminated the memory will be freed.
  FreeOnTerminate := True;

  inherited Create(CreateSuspended);
end;

procedure TSimpleThread.Execute;
var
  i: integer;
  f: real;
begin
  while (not Terminated) do
  begin
    //Do some integer and float calulation to stress the CPU.
    //The complexity of calulation does'nt seem to matter.
    i := 2563 * 256;
    f := 25 / 98;

    //Just to avoid compiler notes.
    i := i;
    f := f;
  end;
end;

end.
